#line 1 "D:/Proekti/Frequency Meter 50MHz/Ar2r.c"

const unsigned short TEMP_RESOLUTION = 12;
const int RES_FACTOR_1[4] = {5000, 2500, 1250, 625};
const unsigned int RES_FACTOR_2[4] = {0x0001, 0x0003, 0x0007, 0x000F};
const unsigned int RES_FACTOR_3[4] = {0x8000, 0xC000, 0xE000, 0xF000};
unsigned short RES_SHIFT;



void Ar2rSplash(void)
{
 unsigned char *text="Frequency Meter";

 LCD_Cmd(LCD_CLEAR);

 LCD_Out(1,1,text);
 text="by Ar2r";
 LCD_Out(2,7,text);

 Delay_ms(1500);
}



unsigned short BCDMask(unsigned short num)
{
 unsigned short bmask;

 switch (num)
 {
 case 0 : bmask=(0x3F); break;
 case 1 : bmask=(0x06); break;
 case 2 : bmask=(0x5B); break;
 case 3 : bmask=(0x4F); break;
 case 4 : bmask=(0x66); break;
 case 5 : bmask=(0x6D); break;
 case 6 : bmask=(0x7D); break;
 case 7 : bmask=(0x07); break;
 case 8 : bmask=(0x7F); break;
 case 9 : bmask=(0x6F); break;
 }

 return (bmask);
}



unsigned short IsLeapYear(unsigned int yea)
{
 unsigned int ty;
 ty=yea%4;
 if(ty==0) return(1);
 else return(0);
}



unsigned short Days(unsigned short mon, unsigned int ye)
{
 unsigned short tempd;

 switch (mon)
 {
 case 1 : tempd=(31);
 case 2 : tempd=(28+IsLeapYear(ye));
 case 3 : tempd=(31);
 case 4 : tempd=(30);
 case 5 : tempd=(31);
 case 6 : tempd=(30);
 case 7 : tempd=(31);
 case 8 : tempd=(31);
 case 9 : tempd=(30);
 case 10 : tempd=(31);
 case 11 : tempd=(30);
 case 12 : tempd=(31);
 }
 return (tempd);
}



unsigned short dstm(unsigned int mye)
{
 unsigned int x;
 unsigned short mdstm=28;

 for(x=2000;x<=mye;x++)
 {
 if(IsLeapYear(x)==1) mdstm--;

 mdstm--;
 if(mdstm<=24) mdstm+=7;
 }

 return (mdstm);
}



unsigned short dsto(unsigned int yeo)
{
 unsigned short odsto, odstm;

 odstm=dstm(yeo);
 odsto=odstm+3;
 if(odsto>=32) odsto-=7;

 return (odsto);
}



unsigned ConTemp(unsigned temp)
{
 unsigned short RES_SHIFT = TEMP_RESOLUTION - 8;
 unsigned int temp_whole, temp_fraction;
 unsigned short i;


 temp_fraction = temp & RES_FACTOR_2[RES_SHIFT - 1];
 temp_fraction = temp_fraction * RES_FACTOR_1[RES_SHIFT - 1];

 temp_whole = temp;


 if ((temp_whole & 0x8000) != 0u) i = 1;
 else i = 0;

 temp_whole >>= RES_SHIFT;

 if (i) temp_whole |= RES_FACTOR_3[RES_SHIFT - 1];

 return (temp_whole);
}
